(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('util'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('ngx-route-highlighter', ['exports', '@angular/core', '@angular/common', 'util', '@angular/router'], factory) :
    (global = global || self, factory(global['ngx-route-highlighter'] = {}, global.ng.core, global.ng.common, global.util, global.ng.router));
}(this, (function (exports, core, common, util, router) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxRouteHighlighterConfig = /** @class */ (function () {
        function NgxRouteHighlighterConfig(config) {
            this.config = config;
        }
        /**
         * @param {?} url
         * @param {?=} className
         * @return {?}
         */
        NgxRouteHighlighterConfig.prototype.getNormalConfig = /**
         * @param {?} url
         * @param {?=} className
         * @return {?}
         */
        function (url, className) {
            this.config = {
                className: className ? className : 'active',
                links: url,
                strict: false
            };
            return new NgxRouteHighlighterConfig(this.config);
        };
        /**
         * @param {?} url
         * @param {?=} className
         * @return {?}
         */
        NgxRouteHighlighterConfig.prototype.getStrictConfig = /**
         * @param {?} url
         * @param {?=} className
         * @return {?}
         */
        function (url, className) {
            this.config = {
                className: className ? className : 'active',
                links: url,
                strict: true
            };
            return new NgxRouteHighlighterConfig(this.config);
        };
        return NgxRouteHighlighterConfig;
    }());
    if (false) {
        /** @type {?} */
        NgxRouteHighlighterConfig.prototype.config;
    }
    /**
     * @record
     */
    function LinksEntity() { }
    if (false) {
        /** @type {?} */
        LinksEntity.prototype.links;
        /** @type {?} */
        LinksEntity.prototype.className;
        /** @type {?|undefined} */
        LinksEntity.prototype.strict;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RouteHighlighterDirective = /** @class */ (function () {
        function RouteHighlighterDirective(el, location, r2, router$1) {
            var _this = this;
            this.el = el;
            this.location = location;
            this.r2 = r2;
            this.router = router$1;
            this.defaultConfig = {
                className: 'active',
                links: null,
                strict: false
            };
            this.ngxRouteHighlighter = new NgxRouteHighlighterConfig(this.defaultConfig);
            this.activeClass = 'active';
            router$1.events.subscribe((/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                if (event instanceof router.NavigationStart) {
                    console.log('navigation start and removed class');
                    _this.r2.removeClass(_this.el.nativeElement, _this.activeClass);
                }
                else if (event instanceof router.NavigationEnd) {
                    _this.setClass();
                }
            }));
        }
        /**
         * @return {?}
         */
        RouteHighlighterDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.ngxRouteHighlighter = new NgxRouteHighlighterConfig(this.defaultConfig);
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        RouteHighlighterDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            this.ngxRouteHighlighter = changes.ngxRouteHighlighter.currentValue;
            console.log(this.ngxRouteHighlighter.config);
            if (this.ngxRouteHighlighter.config) {
                this.activeClass = this.ngxRouteHighlighter.config.className ? this.ngxRouteHighlighter.config.className : 'active';
            }
            else {
                this.activeClass = 'active';
            }
            // this.setClass();
        };
        /**
         * @return {?}
         */
        RouteHighlighterDirective.prototype.setClass = /**
         * @return {?}
         */
        function () {
            if (this.ngxRouteHighlighter instanceof NgxRouteHighlighterConfig) {
                // console.log(this.ngxRouteHighlighter.config);
                if (util.isArray(this.ngxRouteHighlighter.config.links) && this.ngxRouteHighlighter.config.links !== null) {
                    if (this.linkMatcher(this.ngxRouteHighlighter.config.links, this.ngxRouteHighlighter.config.strict)) {
                        // console.log('addingclass to')
                        this.r2.addClass(this.el.nativeElement, this.activeClass);
                    }
                    else {
                        // console.log('removing class to')
                        // this.r2.removeClass(this.el.nativeElement, this.activeClass);
                    }
                }
                else {
                    throw Error('ngx Route Highlighter Directive needs links as <array> of <String> where provided data is of TYPE => ' + typeof (this.ngxRouteHighlighter));
                }
            }
            else {
                throw Error('ngx Route Highlighter Directive needs <NgxRouteHighlighterConfig> where provided data is of TYPE => ' + typeof (this.ngxRouteHighlighter));
            }
        };
        /**
         * @param {?} links
         * @param {?=} strict
         * @return {?}
         */
        RouteHighlighterDirective.prototype.linkMatcher = /**
         * @param {?} links
         * @param {?=} strict
         * @return {?}
         */
        function (links, strict) {
            var _this = this;
            /** @type {?} */
            var foundMatch = false;
            /** @type {?} */
            var temp = [];
            console.log('started machinig links');
            if (!strict) {
                strict = false;
            }
            // console.log(links)
            links.forEach((/**
             * @param {?} link
             * @return {?}
             */
            function (link) {
                if (strict) {
                    if (_this.location.path().includes(link)) {
                        foundMatch = true;
                        console.log(_this.el.nativeElement, 'added');
                        temp.push(link);
                    }
                }
                else {
                    if (_this.location.path() === link) {
                        foundMatch = true;
                        console.log(_this.el.nativeElement, 'added');
                        temp.push(link);
                    }
                }
            }));
            console.log('from', links, 'Matched Links are', temp);
            return foundMatch;
        };
        RouteHighlighterDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngxRouteHighlighter]',
                        providers: [common.Location, { provide: common.LocationStrategy, useClass: common.PathLocationStrategy }],
                    },] }
        ];
        /** @nocollapse */
        RouteHighlighterDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: common.Location },
            { type: core.Renderer2 },
            { type: router.Router }
        ]; };
        RouteHighlighterDirective.propDecorators = {
            ngxRouteHighlighter: [{ type: core.Input }],
            activeClass: [{ type: core.Input }]
        };
        return RouteHighlighterDirective;
    }());
    if (false) {
        /** @type {?} */
        RouteHighlighterDirective.prototype.defaultConfig;
        /** @type {?} */
        RouteHighlighterDirective.prototype.ngxRouteHighlighter;
        /** @type {?} */
        RouteHighlighterDirective.prototype.activeClass;
        /**
         * @type {?}
         * @private
         */
        RouteHighlighterDirective.prototype.el;
        /**
         * @type {?}
         * @private
         */
        RouteHighlighterDirective.prototype.location;
        /**
         * @type {?}
         * @private
         */
        RouteHighlighterDirective.prototype.r2;
        /**
         * @type {?}
         * @private
         */
        RouteHighlighterDirective.prototype.router;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxRouteHighlighterModule = /** @class */ (function () {
        function NgxRouteHighlighterModule() {
        }
        /**
         * @param {?} router
         * @return {?}
         */
        NgxRouteHighlighterModule.forRoot = /**
         * @param {?} router
         * @return {?}
         */
        function (router) {
            return {
                ngModule: NgxRouteHighlighterModule,
                imports: [
                    router,
                ]
            };
        };
        NgxRouteHighlighterModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [RouteHighlighterDirective],
                        imports: [],
                        exports: [RouteHighlighterDirective],
                    },] }
        ];
        return NgxRouteHighlighterModule;
    }());

    exports.NgxRouteHighlighterConfig = NgxRouteHighlighterConfig;
    exports.NgxRouteHighlighterModule = NgxRouteHighlighterModule;
    exports.RouteHighlighterDirective = RouteHighlighterDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-route-highlighter.umd.js.map
