import { Directive, ElementRef, Renderer2, Input, NgModule } from '@angular/core';
import { Location, LocationStrategy, PathLocationStrategy } from '@angular/common';
import { isArray } from 'util';
import { NavigationStart, NavigationEnd, Router } from '@angular/router';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxRouteHighlighterConfig = /** @class */ (function () {
    function NgxRouteHighlighterConfig(config) {
        this.config = config;
    }
    /**
     * @param {?} url
     * @param {?=} className
     * @return {?}
     */
    NgxRouteHighlighterConfig.prototype.getNormalConfig = /**
     * @param {?} url
     * @param {?=} className
     * @return {?}
     */
    function (url, className) {
        this.config = {
            className: className ? className : 'active',
            links: url,
            strict: false
        };
        return new NgxRouteHighlighterConfig(this.config);
    };
    /**
     * @param {?} url
     * @param {?=} className
     * @return {?}
     */
    NgxRouteHighlighterConfig.prototype.getStrictConfig = /**
     * @param {?} url
     * @param {?=} className
     * @return {?}
     */
    function (url, className) {
        this.config = {
            className: className ? className : 'active',
            links: url,
            strict: true
        };
        return new NgxRouteHighlighterConfig(this.config);
    };
    return NgxRouteHighlighterConfig;
}());
if (false) {
    /** @type {?} */
    NgxRouteHighlighterConfig.prototype.config;
}
/**
 * @record
 */
function LinksEntity() { }
if (false) {
    /** @type {?} */
    LinksEntity.prototype.links;
    /** @type {?} */
    LinksEntity.prototype.className;
    /** @type {?|undefined} */
    LinksEntity.prototype.strict;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RouteHighlighterDirective = /** @class */ (function () {
    function RouteHighlighterDirective(el, location, r2, router) {
        var _this = this;
        this.el = el;
        this.location = location;
        this.r2 = r2;
        this.router = router;
        this.defaultConfig = {
            className: 'active',
            links: null,
            strict: false
        };
        this.ngxRouteHighlighter = new NgxRouteHighlighterConfig(this.defaultConfig);
        this.activeClass = 'active';
        router.events.subscribe((/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event instanceof NavigationStart) {
                console.log('navigation start and removed class');
                _this.r2.removeClass(_this.el.nativeElement, _this.activeClass);
            }
            else if (event instanceof NavigationEnd) {
                _this.setClass();
            }
        }));
    }
    /**
     * @return {?}
     */
    RouteHighlighterDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.ngxRouteHighlighter = new NgxRouteHighlighterConfig(this.defaultConfig);
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    RouteHighlighterDirective.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        this.ngxRouteHighlighter = changes.ngxRouteHighlighter.currentValue;
        console.log(this.ngxRouteHighlighter.config);
        if (this.ngxRouteHighlighter.config) {
            this.activeClass = this.ngxRouteHighlighter.config.className ? this.ngxRouteHighlighter.config.className : 'active';
        }
        else {
            this.activeClass = 'active';
        }
        // this.setClass();
    };
    /**
     * @return {?}
     */
    RouteHighlighterDirective.prototype.setClass = /**
     * @return {?}
     */
    function () {
        if (this.ngxRouteHighlighter instanceof NgxRouteHighlighterConfig) {
            // console.log(this.ngxRouteHighlighter.config);
            if (isArray(this.ngxRouteHighlighter.config.links) && this.ngxRouteHighlighter.config.links !== null) {
                if (this.linkMatcher(this.ngxRouteHighlighter.config.links, this.ngxRouteHighlighter.config.strict)) {
                    // console.log('addingclass to')
                    this.r2.addClass(this.el.nativeElement, this.activeClass);
                }
                else {
                    // console.log('removing class to')
                    // this.r2.removeClass(this.el.nativeElement, this.activeClass);
                }
            }
            else {
                throw Error('ngx Route Highlighter Directive needs links as <array> of <String> where provided data is of TYPE => ' + typeof (this.ngxRouteHighlighter));
            }
        }
        else {
            throw Error('ngx Route Highlighter Directive needs <NgxRouteHighlighterConfig> where provided data is of TYPE => ' + typeof (this.ngxRouteHighlighter));
        }
    };
    /**
     * @param {?} links
     * @param {?=} strict
     * @return {?}
     */
    RouteHighlighterDirective.prototype.linkMatcher = /**
     * @param {?} links
     * @param {?=} strict
     * @return {?}
     */
    function (links, strict) {
        var _this = this;
        /** @type {?} */
        var foundMatch = false;
        /** @type {?} */
        var temp = [];
        console.log('started machinig links');
        if (!strict) {
            strict = false;
        }
        // console.log(links)
        links.forEach((/**
         * @param {?} link
         * @return {?}
         */
        function (link) {
            if (strict) {
                if (_this.location.path().includes(link)) {
                    foundMatch = true;
                    console.log(_this.el.nativeElement, 'added');
                    temp.push(link);
                }
            }
            else {
                if (_this.location.path() === link) {
                    foundMatch = true;
                    console.log(_this.el.nativeElement, 'added');
                    temp.push(link);
                }
            }
        }));
        console.log('from', links, 'Matched Links are', temp);
        return foundMatch;
    };
    RouteHighlighterDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxRouteHighlighter]',
                    providers: [Location, { provide: LocationStrategy, useClass: PathLocationStrategy }],
                },] }
    ];
    /** @nocollapse */
    RouteHighlighterDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Location },
        { type: Renderer2 },
        { type: Router }
    ]; };
    RouteHighlighterDirective.propDecorators = {
        ngxRouteHighlighter: [{ type: Input }],
        activeClass: [{ type: Input }]
    };
    return RouteHighlighterDirective;
}());
if (false) {
    /** @type {?} */
    RouteHighlighterDirective.prototype.defaultConfig;
    /** @type {?} */
    RouteHighlighterDirective.prototype.ngxRouteHighlighter;
    /** @type {?} */
    RouteHighlighterDirective.prototype.activeClass;
    /**
     * @type {?}
     * @private
     */
    RouteHighlighterDirective.prototype.el;
    /**
     * @type {?}
     * @private
     */
    RouteHighlighterDirective.prototype.location;
    /**
     * @type {?}
     * @private
     */
    RouteHighlighterDirective.prototype.r2;
    /**
     * @type {?}
     * @private
     */
    RouteHighlighterDirective.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxRouteHighlighterModule = /** @class */ (function () {
    function NgxRouteHighlighterModule() {
    }
    /**
     * @param {?} router
     * @return {?}
     */
    NgxRouteHighlighterModule.forRoot = /**
     * @param {?} router
     * @return {?}
     */
    function (router) {
        return {
            ngModule: NgxRouteHighlighterModule,
            imports: [
                router,
            ]
        };
    };
    NgxRouteHighlighterModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [RouteHighlighterDirective],
                    imports: [],
                    exports: [RouteHighlighterDirective],
                },] }
    ];
    return NgxRouteHighlighterModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxRouteHighlighterConfig, NgxRouteHighlighterModule, RouteHighlighterDirective };
//# sourceMappingURL=ngx-route-highlighter.js.map
